import { PropType } from 'vue';
import * as common from 'tree-component';
export * from 'tree-component';
/**
 * @public
 */
export declare const Node: import("vue").DefineComponent<{
    data: {
        type: PropType<common.TreeData<unknown>>;
        required: true;
    };
    last: {
        type: BooleanConstructor;
        required: true;
    };
    checkbox: BooleanConstructor;
    path: {
        type: PropType<number[]>;
        required: true;
    };
    draggable: {
        type: BooleanConstructor;
        required: true;
    };
    root: PropType<common.TreeData<unknown>[]>;
    zindex: NumberConstructor;
    preid: {
        type: StringConstructor;
        required: true;
    };
}, unknown, {
    contextmenuVisible: boolean;
    hovered: boolean;
    doubleClick: common.DoubleClick;
}, {
    contextmenuStyle(): {
        [key: string]: unknown;
    };
    nodeClassName(): string;
    anchorClassName(): string;
    checkboxClassName(): string;
    iconClassName(): string;
    oclClassName(): string;
    pathString(): string;
    hasMarker(): boolean;
    markerClassName(): string;
    eventData(): common.EventData<unknown>;
    id(): string | undefined;
}, {
    geChildPath(index: number): number[];
    hover(hovered: boolean): void;
    ontoggle(eventData?: common.EventData<unknown> | undefined): void;
    onchange(eventData?: common.EventData<unknown> | undefined): void;
    oncontextmenu(e: MouseEvent): false;
    ondragstart(event: DragEvent): void;
    ondragend(event: DragEvent): void;
    ondragover(event: DragEvent): void;
    ondragenter(event: DragEvent): void;
    ondragleave(event: DragEvent): void;
    ondrop(event: DragEvent): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<{
    data?: unknown;
    last?: unknown;
    checkbox?: unknown;
    path?: unknown;
    draggable?: unknown;
    root?: unknown;
    zindex?: unknown;
    preid?: unknown;
} & {
    data: common.TreeData<unknown>;
    last: boolean;
    checkbox: boolean;
    path: number[];
    draggable: boolean;
    preid: string;
} & {
    zindex?: number | undefined;
    root?: common.TreeData<unknown>[] | undefined;
}>, {
    checkbox: boolean;
}>;
/**
 * @public
 */
export declare const Tree: import("vue").DefineComponent<{
    data: {
        type: PropType<common.TreeData<unknown>[]>;
        required: true;
    };
    checkbox: BooleanConstructor;
    draggable: BooleanConstructor;
    nodots: BooleanConstructor;
    size: StringConstructor;
    theme: StringConstructor;
    dropAllowed: PropType<(dropData: common.DropData<unknown>) => boolean>;
    zindex: NumberConstructor;
    preid: StringConstructor;
    dragTarget: PropType<common.DragTargetData<unknown>>;
}, unknown, {
    localDragTarget: HTMLElement | null;
    dropTarget: HTMLElement | null;
}, {
    rootClassName(): string;
    containerClassName(): string;
}, {
    ontoggle(eventData: common.EventData<unknown>): void;
    onchange(eventData: common.EventData<unknown>): void;
    ondragstart(event: DragEvent): void;
    ondragend(event: DragEvent): void;
    ondragover(event: DragEvent): void;
    ondragenter(event: DragEvent): void;
    ondragleave(event: DragEvent): void;
    ondrop(event: DragEvent): void;
    canDrop(event: DragEvent): string | false | undefined;
    containsNode(parentNode: HTMLElement, node: HTMLElement): boolean;
    getAnchor(target: HTMLElement): HTMLElement;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("drop" | "toggle" | "change" | "change-drag-target")[], "drop" | "toggle" | "change" | "change-drag-target", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<{
    data?: unknown;
    checkbox?: unknown;
    draggable?: unknown;
    nodots?: unknown;
    size?: unknown;
    theme?: unknown;
    dropAllowed?: unknown;
    zindex?: unknown;
    preid?: unknown;
    dragTarget?: unknown;
} & {
    data: common.TreeData<unknown>[];
    checkbox: boolean;
    draggable: boolean;
    nodots: boolean;
} & {
    zindex?: number | undefined;
    preid?: string | undefined;
    size?: string | undefined;
    theme?: string | undefined;
    dropAllowed?: ((dropData: common.DropData<unknown>) => boolean) | undefined;
    dragTarget?: common.DragTargetData<unknown> | undefined;
}>, {
    checkbox: boolean;
    draggable: boolean;
    nodots: boolean;
}>;
